import javax.swing.*;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;
import java.awt.FlowLayout;
import java.awt.Color;
import java.awt.event.*;
import java.text.NumberFormat;
import java.util.Locale;

class MoneyFrame extends JFrame implements DocumentListener, 
                                           ItemListener, 
                                           MouseListener {
    JTextField textField = new JTextField(5);
    JComboBox combo = new JComboBox();
    JLabel label = new JLabel("           ");

    NumberFormat currencyUS = 
        NumberFormat.getCurrencyInstance();
    NumberFormat currencyUK = 
        NumberFormat.getCurrencyInstance(Locale.UK);

    public MoneyFrame() {
        setLayout(new FlowLayout());

        add(textField);
        combo.addItem("US");
        combo.addItem("UK");
        add(combo);
        add(label);

        textField.getDocument().addDocumentListener(this);
        combo.addItemListener(this);
        label.addMouseListener(this);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        setSize(300, 100);
        setVisible(true);
    }

    void setTextOnLabel() {
        String amountString = "";

        try {
            double amount = 
                Double.parseDouble(textField.getText());

            if (combo.getSelectedItem().equals("US"))
                amountString = currencyUS.format(amount);
            if (combo.getSelectedItem().equals("UK"))
                amountString = currencyUK.format(amount);
            
        } catch (NumberFormatException e) {
        }

        label.setText(amountString);
    }

    public void insertUpdate(DocumentEvent d) {
        setTextOnLabel();
    }

    public void removeUpdate(DocumentEvent d) {
        setTextOnLabel();
    }

    public void changedUpdate(DocumentEvent d) {
    }

    public void itemStateChanged(ItemEvent i) {
        setTextOnLabel();
    }

    public void mouseEntered(MouseEvent m) {
        label.setForeground(Color.red);
    }

    public void mouseExited(MouseEvent m) {
        label.setForeground(Color.black);
    }

    public void mouseClicked(MouseEvent m) {
    }

    public void mousePressed(MouseEvent m) {
    }

    public void mouseReleased(MouseEvent m) {
    }
}
